diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/capabilities.php ./wordpress-3.3/wp-includes/capabilities.php
*** ./wordpress-3.2.1/wp-includes/capabilities.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/capabilities.php	2011-11-17 14:40:24.000000000 -0600
***************
*** 205,211 ****
  	 * @param string $role Role name.
  	 * @return object|null Null, if role does not exist. WP_Role object, if found.
  	 */
! 	function &get_role( $role ) {
  		if ( isset( $this->role_objects[$role] ) )
  			return $this->role_objects[$role];
  		else
--- 205,211 ----
  	 * @param string $role Role name.
  	 * @return object|null Null, if role does not exist. WP_Role object, if found.
  	 */
! 	function get_role( $role ) {
  		if ( isset( $this->role_objects[$role] ) )
  			return $this->role_objects[$role];
  		else
***************
*** 360,367 ****
  	/**
  	 * User data container.
  	 *
- 	 * This will be set as properties of the object.
- 	 *
  	 * @since 2.0.0
  	 * @access private
  	 * @var array
--- 360,365 ----
***************
*** 378,394 ****
  	var $ID = 0;
  
  	/**
- 	 * The deprecated user's ID.
- 	 *
- 	 * @since 2.0.0
- 	 * @access public
- 	 * @deprecated Use WP_User::$ID
- 	 * @see WP_User::$ID
- 	 * @var int
- 	 */
- 	var $id = 0;
- 
- 	/**
  	 * The individual capabilities the user has been given.
  	 *
  	 * @since 2.0.0
--- 376,381 ----
***************
*** 425,452 ****
  	var $allcaps = array();
  
  	/**
- 	 * First name of the user.
- 	 *
- 	 * Created to prevent notices.
- 	 *
- 	 * @since 2.7.0
- 	 * @access public
- 	 * @var string
- 	 */
- 	var $first_name = '';
- 
- 	/**
- 	 * Last name of the user.
- 	 *
- 	 * Created to prevent notices.
- 	 *
- 	 * @since 2.7.0
- 	 * @access public
- 	 * @var string
- 	 */
- 	var $last_name = '';
- 
- 	/**
  	 * The filter context applied to user data fields.
  	 *
  	 * @since 2.9.0
--- 412,417 ----
***************
*** 455,502 ****
  	 */
  	var $filter = null;
  
  	/**
! 	 * Constructor - Sets up the object properties.
  	 *
! 	 * Retrieves the userdata and then assigns all of the data keys to direct
! 	 * properties of the object. Calls {@link WP_User::_init_caps()} after
! 	 * setting up the object's user data properties.
  	 *
  	 * @since 2.0.0
  	 * @access public
  	 *
! 	 * @param int|string $id User's ID or username
! 	 * @param int $name Optional. User's username
  	 * @param int $blog_id Optional Blog ID, defaults to current blog.
  	 * @return WP_User
  	 */
! 	function __construct( $id, $name = '', $blog_id = '' ) {
! 
! 		if ( empty( $id ) && empty( $name ) )
! 			return;
  
! 		if ( ! is_numeric( $id ) ) {
  			$name = $id;
  			$id = 0;
  		}
  
! 		if ( ! empty( $id ) )
! 			$this->data = get_userdata( $id );
  		else
! 			$this->data = get_userdatabylogin( $name );
  
! 		if ( empty( $this->data->ID ) )
! 			return;
  
! 		foreach ( get_object_vars( $this->data ) as $key => $value ) {
! 			$this->{$key} = $value;
! 		}
  
- 		$this->id = $this->ID;
  		$this->for_blog( $blog_id );
  	}
  
  	/**
  	 * Set up capability object properties.
  	 *
  	 * Will set the value for the 'cap_key' property to current database table
--- 420,625 ----
  	 */
  	var $filter = null;
  
+ 	private static $back_compat_keys;
+ 
  	/**
! 	 * Constructor
  	 *
! 	 * Retrieves the userdata and passes it to {@link WP_User::init()}.
  	 *
  	 * @since 2.0.0
  	 * @access public
  	 *
! 	 * @param int|string $id User's ID
! 	 * @param string $name Optional. User's username
  	 * @param int $blog_id Optional Blog ID, defaults to current blog.
  	 * @return WP_User
  	 */
! 	function __construct( $id = 0, $name = '', $blog_id = '' ) {
! 		if ( ! isset( self::$back_compat_keys ) ) {
! 			$prefix = $GLOBALS['wpdb']->prefix;
! 			self::$back_compat_keys = array(
! 				'user_firstname' => 'first_name',
! 				'user_lastname' => 'last_name',
! 				'user_description' => 'description',
! 				'user_level' => $prefix . 'user_level',
! 				$prefix . 'usersettings' => $prefix . 'user-settings',
! 				$prefix . 'usersettingstime' => $prefix . 'user-settings-time',
! 			);
! 		}
  
! 		if ( ! empty( $id ) && ! is_numeric( $id ) ) {
  			$name = $id;
  			$id = 0;
  		}
  
! 		if ( $id )
! 			$data = self::get_data_by( 'id', $id );
  		else
! 			$data = self::get_data_by( 'login', $name );
  
! 		if ( $data )
! 			$this->init( $data, $blog_id );
! 	}
  
! 	/**
! 	 * Sets up object properties, including capabilities.
! 	 *
! 	 * @param object $data User DB row object
! 	 * @param int $blog_id Optional. The blog id to initialize for
! 	 */
! 	function init( $data, $blog_id = '' ) {
! 		$this->data = $data;
! 		$this->ID = (int) $data->ID;
  
  		$this->for_blog( $blog_id );
  	}
  
  	/**
+ 	 * Return only the main user fields
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * @param string $field The field to query against: 'id', 'slug', 'email' or 'login'
+ 	 * @param string|int $value The field value
+ 	 * @return object Raw user object
+ 	 */
+ 	static function get_data_by( $field, $value ) {
+ 		global $wpdb;
+ 
+ 		if ( 'id' == $field )
+ 			$value = absint( $value );
+ 		else
+ 			$value = trim( $value );
+ 
+ 		if ( !$value )
+ 			return false;
+ 
+ 		switch ( $field ) {
+ 			case 'id':
+ 				$user_id = $value;
+ 				$db_field = 'ID';
+ 				break;
+ 			case 'slug':
+ 				$user_id = wp_cache_get($value, 'userslugs');
+ 				$db_field = 'user_nicename';
+ 				break;
+ 			case 'email':
+ 				$user_id = wp_cache_get($value, 'useremail');
+ 				$db_field = 'user_email';
+ 				break;
+ 			case 'login':
+ 				$value = sanitize_user( $value );
+ 				$user_id = wp_cache_get($value, 'userlogins');
+ 				$db_field = 'user_login';
+ 				break;
+ 			default:
+ 				return false;
+ 		}
+ 
+ 		if ( false !== $user_id ) {
+ 			if ( $user = wp_cache_get( $user_id, 'users' ) )
+ 				return $user;
+ 		}
+ 
+ 		if ( !$user = $wpdb->get_row( $wpdb->prepare(
+ 			"SELECT * FROM $wpdb->users WHERE $db_field = %s", $value
+ 		) ) )
+ 			return false;
+ 
+ 		update_user_caches( $user );
+ 
+ 		return $user;
+ 	}
+ 
+ 	/**
+ 	 * Magic method for checking the existence of a certain custom field
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	function __isset( $key ) {
+ 		if ( 'id' == $key ) {
+ 			_deprecated_argument( 'WP_User->id', '2.1', __( 'Use <code>WP_User->ID</code> instead.' ) );
+ 			$key = 'ID';
+ 		}
+ 
+ 		if ( isset( $this->data->$key ) )
+ 			return true;
+ 
+ 		if ( isset( self::$back_compat_keys[ $key ] ) )
+ 			$key = self::$back_compat_keys[ $key ];
+ 
+ 		return metadata_exists( 'user', $this->ID, $key );
+ 	}
+ 
+ 	/**
+ 	 * Magic method for accessing custom fields
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	function __get( $key ) {
+ 		if ( 'id' == $key ) {
+ 			_deprecated_argument( 'WP_User->id', '2.1', __( 'Use <code>WP_User->ID</code> instead.' ) );
+ 			return $this->ID;
+ 		}
+ 
+ 		if ( isset( $this->data->$key ) ) {
+ 			$value = $this->data->$key;
+ 		} else {
+ 			if ( isset( self::$back_compat_keys[ $key ] ) )
+ 				$key = self::$back_compat_keys[ $key ];
+ 			$value = get_user_meta( $this->ID, $key, true );
+ 		}
+ 
+ 		if ( $this->filter ) {
+ 			$value = sanitize_user_field( $key, $value, $this->ID, $this->filter );
+ 		}
+ 
+ 		return $value;
+ 	}
+ 
+ 	/**
+ 	 * Magic method for setting custom fields
+ 	 *
+ 	 * @since 3.3.0
+ 	 */
+ 	function __set( $key, $value ) {
+ 		if ( 'id' == $key ) {
+ 			_deprecated_argument( 'WP_User->id', '2.1', __( 'Use <code>WP_User->ID</code> instead.' ) );
+ 			$this->ID = $value;
+ 			return;
+ 		}
+ 
+ 		$this->data->$key = $value;
+ 	}
+ 
+ 	/**
+ 	 * Retrieve the value of a property or meta key.
+ 	 *
+ 	 * Retrieves from the users and usermeta table.
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * @param string $key Property
+ 	 */
+ 	function get( $key ) {
+ 		return $this->__get( $key );
+ 	}
+ 
+ 	/**
+ 	 * Determine whether a property or meta key is set
+ 	 *
+ 	 * Consults the users and usermeta tables.
+ 	 *
+ 	 * @since 3.3.0
+ 	 *
+ 	 * @param string $key Property
+ 	 */
+ 	function has_prop( $key ) {
+ 		return $this->__isset( $key );
+ 	}
+ 
+ 	/**
  	 * Set up capability object properties.
  	 *
  	 * Will set the value for the 'cap_key' property to current database table
***************
*** 504,513 ****
  	 * property matching the 'cap_key' exists and is an array. If so, it will be
  	 * used.
  	 *
  	 * @since 2.1.0
  	 *
  	 * @param string $cap_key Optional capability key
- 	 * @access protected
  	 */
  	function _init_caps( $cap_key = '' ) {
  		global $wpdb;
--- 627,636 ----
  	 * property matching the 'cap_key' exists and is an array. If so, it will be
  	 * used.
  	 *
+ 	 * @access protected
  	 * @since 2.1.0
  	 *
  	 * @param string $cap_key Optional capability key
  	 */
  	function _init_caps( $cap_key = '' ) {
  		global $wpdb;
***************
*** 515,523 ****
  			$this->cap_key = $wpdb->prefix . 'capabilities';
  		else
  			$this->cap_key = $cap_key;
! 		$this->caps = &$this->{$this->cap_key};
  		if ( ! is_array( $this->caps ) )
  			$this->caps = array();
  		$this->get_role_caps();
  	}
  
--- 639,650 ----
  			$this->cap_key = $wpdb->prefix . 'capabilities';
  		else
  			$this->cap_key = $cap_key;
! 
! 		$this->caps = get_user_meta( $this->ID, $this->cap_key, true );
! 
  		if ( ! is_array( $this->caps ) )
  			$this->caps = array();
+ 
  		$this->get_role_caps();
  	}
  
***************
*** 546,552 ****
  		//Build $allcaps from role caps, overlay user's $caps
  		$this->allcaps = array();
  		foreach ( (array) $this->roles as $role ) {
! 			$the_role =& $wp_roles->get_role( $role );
  			$this->allcaps = array_merge( (array) $this->allcaps, (array) $the_role->capabilities );
  		}
  		$this->allcaps = array_merge( (array) $this->allcaps, (array) $this->caps );
--- 673,679 ----
  		//Build $allcaps from role caps, overlay user's $caps
  		$this->allcaps = array();
  		foreach ( (array) $this->roles as $role ) {
! 			$the_role = $wp_roles->get_role( $role );
  			$this->allcaps = array_merge( (array) $this->allcaps, (array) $the_role->capabilities );
  		}
  		$this->allcaps = array_merge( (array) $this->allcaps, (array) $this->caps );
***************
*** 657,663 ****
  	 */
  	function update_user_level_from_caps() {
  		global $wpdb;
! 		$this->user_level = array_reduce( array_keys( $this->allcaps ), array( &$this, 'level_reduction' ), 0 );
  		update_user_meta( $this->ID, $wpdb->prefix . 'user_level', $this->user_level );
  	}
  
--- 784,790 ----
  	 */
  	function update_user_level_from_caps() {
  		global $wpdb;
! 		$this->user_level = array_reduce( array_keys( $this->allcaps ), array( $this, 'level_reduction' ), 0 );
  		update_user_meta( $this->ID, $wpdb->prefix . 'user_level', $this->user_level );
  	}
  
***************
*** 709,715 ****
  	 *
  	 * This is useful for looking up whether the user has a specific role
  	 * assigned to the user. The second optional parameter can also be used to
! 	 * check for capabilities against a specfic post.
  	 *
  	 * @since 2.0.0
  	 * @access public
--- 836,842 ----
  	 *
  	 * This is useful for looking up whether the user has a specific role
  	 * assigned to the user. The second optional parameter can also be used to
! 	 * check for capabilities against a specific post.
  	 *
  	 * @since 2.0.0
  	 * @access public
***************
*** 739,746 ****
  		$capabilities = apply_filters( 'user_has_cap', $this->allcaps, $caps, $args );
  		$capabilities['exist'] = true; // Everyone is allowed to exist
  		foreach ( (array) $caps as $cap ) {
! 			//echo "Checking cap $cap<br />";
! 			if ( empty( $capabilities[$cap] ) || !$capabilities[$cap] )
  				return false;
  		}
  
--- 866,872 ----
  		$capabilities = apply_filters( 'user_has_cap', $this->allcaps, $caps, $args );
  		$capabilities['exist'] = true; // Everyone is allowed to exist
  		foreach ( (array) $caps as $cap ) {
! 			if ( empty( $capabilities[ $cap ] ) )
  				return false;
  		}
  
***************
*** 951,956 ****
--- 1077,1099 ----
  		else
  			$caps[] = $post_type->cap->read_private_posts;
  		break;
+ 	case 'edit_post_meta':
+ 	case 'delete_post_meta':
+ 	case 'add_post_meta':
+ 		$post = get_post( $args[0] );
+ 		$post_type_object = get_post_type_object( $post->post_type );
+ 		$caps = map_meta_cap( $post_type_object->cap->edit_post, $user_id, $post->ID );
+ 
+ 		$meta_key = isset( $args[ 1 ] ) ? $args[ 1 ] : false;
+ 
+ 		if ( $meta_key && has_filter( "auth_post_meta_{$meta_key}" ) ) {
+ 			$allowed = apply_filters( "auth_post_meta_{$meta_key}", false, $meta_key, $post->ID, $user_id, $cap, $caps );
+ 			if ( ! $allowed )
+ 				$caps[] = $cap;
+ 		} elseif ( $meta_key && is_protected_meta( $meta_key, 'post' ) ) {
+ 			$caps[] = $cap;
+ 		}
+ 		break;
  	case 'edit_comment':
  		$comment = get_comment( $args[0] );
  		$post = get_post( $comment->comment_post_ID );
***************
*** 1044,1050 ****
  	$args = array_slice( func_get_args(), 1 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( &$current_user, 'has_cap' ), $args );
  }
  
  /**
--- 1187,1193 ----
  	$args = array_slice( func_get_args(), 1 );
  	$args = array_merge( array( $capability ), $args );
  
! 	return call_user_func_array( array( $current_user, 'has_cap' ), $args );
  }
  
  /**
***************
*** 1063,1069 ****
  		return false;
  
  	// Create new object to avoid stomping the global current_user.
! 	$user = new WP_User( $current_user->id) ;
  
  	// Set the blog id.  @todo add blog id arg to WP_User constructor?
  	$user->for_blog( $blog_id );
--- 1206,1212 ----
  		return false;
  
  	// Create new object to avoid stomping the global current_user.
! 	$user = new WP_User( $current_user->ID) ;
  
  	// Set the blog id.  @todo add blog id arg to WP_User constructor?
  	$user->for_blog( $blog_id );
***************
*** 1208,1214 ****
  	else
  		$user = wp_get_current_user();
  
! 	if ( empty( $user->id ) )
  		return false;
  
  	if ( is_multisite() ) {
--- 1351,1357 ----
  	else
  		$user = wp_get_current_user();
  
! 	if ( empty( $user->ID ) )
  		return false;
  
  	if ( is_multisite() ) {
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/category-template.php ./wordpress-3.3/wp-includes/category-template.php
*** ./wordpress-3.2.1/wp-includes/category-template.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/category-template.php	2011-11-14 11:24:14.000000000 -0600
***************
*** 464,474 ****
  				$output .= $show_option_none;
  		}
  	} else {
! 		if( !empty( $show_option_all ) )
  			if ( 'list' == $style )
! 				$output .= '<li><a href="' .  get_bloginfo( 'url' )  . '">' . $show_option_all . '</a></li>';
  			else
! 				$output .= '<a href="' .  get_bloginfo( 'url' )  . '">' . $show_option_all . '</a>';
  
  		if ( empty( $r['current_category'] ) && ( is_category() || is_tax() || is_tag() ) ) {
  			$current_term_object = get_queried_object();
--- 464,477 ----
  				$output .= $show_option_none;
  		}
  	} else {
! 		if ( ! empty( $show_option_all ) ) {
! 			$posts_page = ( 'page' == get_option( 'show_on_front' ) && get_option( 'page_for_posts' ) ) ? get_permalink( get_option( 'page_for_posts' ) ) : home_url( '/' );
! 			$posts_page = esc_url( $posts_page );
  			if ( 'list' == $style )
! 				$output .= "<li><a href='$posts_page'>$show_option_all</a></li>";
  			else
! 				$output .= "<a href='$posts_page'>$show_option_all</a>";
! 		}
  
  		if ( empty( $r['current_category'] ) && ( is_category() || is_tax() || is_tag() ) ) {
  			$current_term_object = get_queried_object();
***************
*** 642,650 ****
  		} else {
  			// SQL cannot save you; this is a second (potentially different) sort on a subset of data.
  			if ( 'name' == $orderby )
! 				uasort( $tags, create_function('$a, $b', 'return strnatcasecmp($a->name, $b->name);') );
  			else
! 				uasort( $tags, create_function('$a, $b', 'return ($a->count > $b->count);') );
  
  			if ( 'DESC' == $order )
  				$tags = array_reverse( $tags, true );
--- 645,653 ----
  		} else {
  			// SQL cannot save you; this is a second (potentially different) sort on a subset of data.
  			if ( 'name' == $orderby )
! 				uasort( $tags, '_wp_object_name_sort_cb' );
  			else
! 				uasort( $tags, '_wp_object_count_sort_cb' );
  
  			if ( 'DESC' == $order )
  				$tags = array_reverse( $tags, true );
***************
*** 704,725 ****
  }
  
  /**
!  * Callback for comparing tags based on name
   *
   * @since 3.1.0
   * @access private
   */
! function _wp_tag_cloud_name_sort_cb( $a, $b ) {
  	return strnatcasecmp( $a->name, $b->name );
  }
  
  /**
!  * Callback for comparing tags based on count
   *
   * @since 3.1.0
   * @access private
   */
! function _wp_tag_cloud_count_sort_cb( $a, $b ) {
  	return ( $a->count > $b->count );
  }
  
--- 707,728 ----
  }
  
  /**
!  * Callback for comparing objects based on name
   *
   * @since 3.1.0
   * @access private
   */
! function _wp_object_name_sort_cb( $a, $b ) {
  	return strnatcasecmp( $a->name, $b->name );
  }
  
  /**
!  * Callback for comparing objects based on count
   *
   * @since 3.1.0
   * @access private
   */
! function _wp_object_count_sort_cb( $a, $b ) {
  	return ( $a->count > $b->count );
  }
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-http.php ./wordpress-3.3/wp-includes/class-http.php
*** ./wordpress-3.2.1/wp-includes/class-http.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-http.php	2011-10-31 14:38:46.000000000 -0500
***************
*** 180,186 ****
  		} else {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
  				$r['body'] = http_build_query( $r['body'], null, '&' );
! 				$r['headers']['Content-Type'] = 'application/x-www-form-urlencoded; charset=' . get_option( 'blog_charset' );
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  			}
  
--- 180,187 ----
  		} else {
  			if ( is_array( $r['body'] ) || is_object( $r['body'] ) ) {
  				$r['body'] = http_build_query( $r['body'], null, '&' );
! 				if ( ! isset( $r['headers']['Content-Type'] ) )
! 					$r['headers']['Content-Type'] = 'application/x-www-form-urlencoded; charset=' . get_option( 'blog_charset' );
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  			}
  
***************
*** 222,228 ****
  	/**
  	 * Dispatches a HTTP request to a supporting transport.
  	 *
! 	 * Tests each transport in order to find a transport which matches the request arguements.
  	 * Also caches the transport instance to be used later.
  	 *
  	 * The order for blocking requests is cURL, Streams, and finally Fsockopen.
--- 223,229 ----
  	/**
  	 * Dispatches a HTTP request to a supporting transport.
  	 *
! 	 * Tests each transport in order to find a transport which matches the request arguments.
  	 * Also caches the transport instance to be used later.
  	 *
  	 * The order for blocking requests is cURL, Streams, and finally Fsockopen.
***************
*** 253,259 ****
  
  		$response = $transports[$class]->request( $url, $args );
  
! 		do_action( 'http_api_debug', $response, 'response', $class );
  
  		if ( is_wp_error( $response ) )
  			return $response;
--- 254,260 ----
  
  		$response = $transports[$class]->request( $url, $args );
  
! 		do_action( 'http_api_debug', $response, 'response', $class, $args, $url );
  
  		if ( is_wp_error( $response ) )
  			return $response;
***************
*** 345,351 ****
  	 * @return array Processed string headers. If duplicate headers are encountered,
  	 * 					Then a numbered array is returned as the value of that header-key.
  	 */
! 	function processHeaders($headers) {
  		// split headers, one per array element
  		if ( is_string($headers) ) {
  			// tolerate line terminator: CRLF = LF (RFC 2616 19.3)
--- 346,352 ----
  	 * @return array Processed string headers. If duplicate headers are encountered,
  	 * 					Then a numbered array is returned as the value of that header-key.
  	 */
! 	public static function processHeaders($headers) {
  		// split headers, one per array element
  		if ( is_string($headers) ) {
  			// tolerate line terminator: CRLF = LF (RFC 2616 19.3)
***************
*** 412,418 ****
  	 *
  	 * @param array $r Full array of args passed into ::request()
  	 */
! 	function buildCookieHeader( &$r ) {
  		if ( ! empty($r['cookies']) ) {
  			$cookies_header = '';
  			foreach ( (array) $r['cookies'] as $cookie ) {
--- 413,419 ----
  	 *
  	 * @param array $r Full array of args passed into ::request()
  	 */
! 	public static function buildCookieHeader( &$r ) {
  		if ( ! empty($r['cookies']) ) {
  			$cookies_header = '';
  			foreach ( (array) $r['cookies'] as $cookie ) {
***************
*** 631,637 ****
  
  		$endDelay = time();
  
! 		// If the delay is greater than the timeout then fsockopen should't be used, because it will
  		// cause a long delay.
  		$elapseDelay = ($endDelay-$startDelay) > $r['timeout'];
  		if ( true === $elapseDelay )
--- 632,638 ----
  
  		$endDelay = time();
  
! 		// If the delay is greater than the timeout then fsockopen shouldn't be used, because it will
  		// cause a long delay.
  		$elapseDelay = ($endDelay-$startDelay) > $r['timeout'];
  		if ( true === $elapseDelay )
***************
*** 755,761 ****
  	 * @static
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	function test( $args = array() ) {
  		if ( ! function_exists( 'fsockopen' ) )
  			return false;
  
--- 756,762 ----
  	 * @static
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	public static function test( $args = array() ) {
  		if ( ! function_exists( 'fsockopen' ) )
  			return false;
  
***************
*** 915,921 ****
  		else
  			$processedHeaders = WP_Http::processHeaders($meta['wrapper_data']);
  
! 		// Streams does not provide an error code which we can use to see why the request stream stoped.
  		// We can however test to see if a location header is present and return based on that.
  		if ( isset($processedHeaders['headers']['location']) && 0 !== $args['_redirection'] )
  			return new WP_Error('http_request_failed', __('Too many redirects.'));
--- 916,922 ----
  		else
  			$processedHeaders = WP_Http::processHeaders($meta['wrapper_data']);
  
! 		// Streams does not provide an error code which we can use to see why the request stream stopped.
  		// We can however test to see if a location header is present and return based on that.
  		if ( isset($processedHeaders['headers']['location']) && 0 !== $args['_redirection'] )
  			return new WP_Error('http_request_failed', __('Too many redirects.'));
***************
*** 938,944 ****
  	 *
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	function test( $args = array() ) {
  		if ( ! function_exists( 'fopen' ) )
  			return false;
  
--- 939,945 ----
  	 *
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	public static function test( $args = array() ) {
  		if ( ! function_exists( 'fopen' ) )
  			return false;
  
***************
*** 1031,1037 ****
  
  
  		// CURLOPT_TIMEOUT and CURLOPT_CONNECTTIMEOUT expect integers.  Have to use ceil since
! 		// a value of 0 will allow an ulimited timeout.
  		$timeout = (int) ceil( $r['timeout'] );
  		curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, $timeout );
  		curl_setopt( $handle, CURLOPT_TIMEOUT, $timeout );
--- 1032,1038 ----
  
  
  		// CURLOPT_TIMEOUT and CURLOPT_CONNECTTIMEOUT expect integers.  Have to use ceil since
! 		// a value of 0 will allow an unlimited timeout.
  		$timeout = (int) ceil( $r['timeout'] );
  		curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, $timeout );
  		curl_setopt( $handle, CURLOPT_TIMEOUT, $timeout );
***************
*** 1117,1123 ****
  				return new WP_Error('http_request_failed', __('Too many redirects.'));
  		}
  
! 		unset( $this->headers );
  
  		$response = array();
  		$response['code'] = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
--- 1118,1124 ----
  				return new WP_Error('http_request_failed', __('Too many redirects.'));
  		}
  
! 		$this->headers = '';
  
  		$response = array();
  		$response['code'] = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
***************
*** 1165,1171 ****
  	 *
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	function test( $args = array() ) {
  		if ( ! function_exists( 'curl_init' ) || ! function_exists( 'curl_exec' ) )
  			return false;
  
--- 1166,1172 ----
  	 *
  	 * @return boolean False means this class can not be used, true means it can.
  	 */
! 	public static function test( $args = array() ) {
  		if ( ! function_exists( 'curl_init' ) || ! function_exists( 'curl_exec' ) )
  			return false;
  
***************
*** 1579,1585 ****
  	 * @param string $supports Optional, not used. When implemented it will choose the right compression based on what the server supports.
  	 * @return string|bool False on failure.
  	 */
! 	function compress( $raw, $level = 9, $supports = null ) {
  		return gzdeflate( $raw, $level );
  	}
  
--- 1580,1586 ----
  	 * @param string $supports Optional, not used. When implemented it will choose the right compression based on what the server supports.
  	 * @return string|bool False on failure.
  	 */
! 	public static function compress( $raw, $level = 9, $supports = null ) {
  		return gzdeflate( $raw, $level );
  	}
  
***************
*** 1597,1603 ****
  	 * @param int $length The optional length of the compressed data.
  	 * @return string|bool False on failure.
  	 */
! 	function decompress( $compressed, $length = null ) {
  
  		if ( empty($compressed) )
  			return $compressed;
--- 1598,1604 ----
  	 * @param int $length The optional length of the compressed data.
  	 * @return string|bool False on failure.
  	 */
! 	public static function decompress( $compressed, $length = null ) {
  
  		if ( empty($compressed) )
  			return $compressed;
***************
*** 1625,1641 ****
  	 * Decompression of deflated string while staying compatible with the majority of servers.
  	 *
  	 * Certain Servers will return deflated data with headers which PHP's gziniflate()
! 	 * function cannot handle out of the box. The following function lifted from
! 	 * http://au2.php.net/manual/en/function.gzinflate.php#77336 will attempt to deflate
! 	 * the various return forms used.
  	 *
  	 * @since 2.8.1
  	 * @link http://au2.php.net/manual/en/function.gzinflate.php#77336
  	 *
  	 * @param string $gzData String to decompress.
  	 * @return string|bool False on failure.
  	 */
! 	function compatible_gzinflate($gzData) {
  		if ( substr($gzData, 0, 3) == "\x1f\x8b\x08" ) {
  			$i = 10;
  			$flg = ord( substr($gzData, 3, 1) );
--- 1626,1650 ----
  	 * Decompression of deflated string while staying compatible with the majority of servers.
  	 *
  	 * Certain Servers will return deflated data with headers which PHP's gziniflate()
! 	 * function cannot handle out of the box. The following function has been created from
! 	 * various snippets on the gzinflate() PHP documentation.
! 	 *
! 	 * Warning: Magic numbers within. Due to the potential different formats that the compressed
! 	 * data may be returned in, some "magic offsets" are needed to ensure proper decompression
! 	 * takes place. For a simple progmatic way to determine the magic offset in use, see:
! 	 * http://core.trac.wordpress.org/ticket/18273
  	 *
  	 * @since 2.8.1
+ 	 * @link http://core.trac.wordpress.org/ticket/18273
+ 	 * @link http://au2.php.net/manual/en/function.gzinflate.php#70875
  	 * @link http://au2.php.net/manual/en/function.gzinflate.php#77336
  	 *
  	 * @param string $gzData String to decompress.
  	 * @return string|bool False on failure.
  	 */
! 	public static function compatible_gzinflate($gzData) {
! 
! 		// Compressed data might contain a full header, if so strip it for gzinflate()
  		if ( substr($gzData, 0, 3) == "\x1f\x8b\x08" ) {
  			$i = 10;
  			$flg = ord( substr($gzData, 3, 1) );
***************
*** 1651,1660 ****
  				if ( $flg & 2 )
  					$i = $i + 2;
  			}
! 			return gzinflate( substr($gzData, $i, -8) );
! 		} else {
! 			return false;
  		}
  	}
  
  	/**
--- 1660,1676 ----
  				if ( $flg & 2 )
  					$i = $i + 2;
  			}
! 			$decompressed = @gzinflate( substr($gzData, $i, -8) );
! 			if ( false !== $decompressed )
! 				return $decompressed;
  		}
+ 
+ 		// Compressed data from java.util.zip.Deflater amongst others.
+ 		$decompressed = @gzinflate( substr($gzData, 2) );
+ 		if ( false !== $decompressed )
+ 			return $decompressed;
+ 
+ 		return false;
  	}
  
  	/**
***************
*** 1664,1670 ****
  	 *
  	 * @return string Types of encoding to accept.
  	 */
! 	function accept_encoding() {
  		$type = array();
  		if ( function_exists( 'gzinflate' ) )
  			$type[] = 'deflate;q=1.0';
--- 1680,1686 ----
  	 *
  	 * @return string Types of encoding to accept.
  	 */
! 	public static function accept_encoding() {
  		$type = array();
  		if ( function_exists( 'gzinflate' ) )
  			$type[] = 'deflate;q=1.0';
***************
*** 1679,1691 ****
  	}
  
  	/**
! 	 * What enconding the content used when it was compressed to send in the headers.
  	 *
  	 * @since 2.8
  	 *
  	 * @return string Content-Encoding string to send in the header.
  	 */
! 	function content_encoding() {
  		return 'deflate';
  	}
  
--- 1695,1707 ----
  	}
  
  	/**
! 	 * What encoding the content used when it was compressed to send in the headers.
  	 *
  	 * @since 2.8
  	 *
  	 * @return string Content-Encoding string to send in the header.
  	 */
! 	public static function content_encoding() {
  		return 'deflate';
  	}
  
***************
*** 1697,1703 ****
  	 * @param array|string $headers All of the available headers.
  	 * @return bool
  	 */
! 	function should_decode($headers) {
  		if ( is_array( $headers ) ) {
  			if ( array_key_exists('content-encoding', $headers) && ! empty( $headers['content-encoding'] ) )
  				return true;
--- 1713,1719 ----
  	 * @param array|string $headers All of the available headers.
  	 * @return bool
  	 */
! 	public static function should_decode($headers) {
  		if ( is_array( $headers ) ) {
  			if ( array_key_exists('content-encoding', $headers) && ! empty( $headers['content-encoding'] ) )
  				return true;
***************
*** 1719,1725 ****
  	 *
  	 * @return bool
  	 */
! 	function is_available() {
  		return ( function_exists('gzuncompress') || function_exists('gzdeflate') || function_exists('gzinflate') );
  	}
  }
--- 1735,1741 ----
  	 *
  	 * @return bool
  	 */
! 	public static function is_available() {
  		return ( function_exists('gzuncompress') || function_exists('gzdeflate') || function_exists('gzinflate') );
  	}
  }
